#include <avr/io.h>

#define F_CPU 1000000UL // 1 MHz
#define USART_BAUDRATE 1200
#define BAUD_PRESCALE (((F_CPU / (USART_BAUDRATE * 16UL))) - 1)



/*Macros definition*/

		      #define BIT(x)	(1 << (x))			//Set a particular bit mask

		      #define CHECKBIT(x,b) x&b			//Checks bit status

		      #define SETBIT(x,b) x|=b;			//Sets the particular bit

		      #define CLEARBIT(x,b) x&=~b;		//Sets the particular bit

		      #define TOGGLEBIT(x,b) x^=b;		//Toggles the particular bit
			  
			  
void WaitMs(unsigned int ms);
			  

int main (void)
{
   static char chr;
   unsigned char Terminator;
   Terminator = '~'; //set this also in matlab 
   char ReceivedByte;
	
	chr = 'n';
   UCSRB |= (1 << RXEN) | (1 << TXEN);   // Turn on the transmission and reception circuitry
   UCSRC = (1<<URSEL)|(1<<USBS)|(3<<UCSZ0);

   UBRRH = (BAUD_PRESCALE >> 8); // Load upper 8-bits of the baud rate value into the high byte of the UBRR register
   UBRRL = BAUD_PRESCALE; // Load lower 8-bits of the baud rate value into the low byte of the UBRR register
   
   
   SETBIT(DDRA,BIT(0))			//Sets Direction of 6th pin of port B as output
   
   CLEARBIT(PORTA,BIT(0))	//Clears PORTB6(PB6 pin goes low) i.e turn off led

   for (;;) // Loop forever
   {
      
	  	do {
			while ((UCSRA & (1 << RXC)) == 0) {}; // Do nothing until data have been received and is ready to be read from UDR
			ReceivedByte = UDR; // Fetch the received byte value into the variable "ByteReceived"
			
			while ((UCSRA & (1 << RXC)) == 0) {}; // Do nothing until data have been received and is ready to be read from UDR
			chr = UDR; // Fetch the received byte value into the variable "ByteReceived"
		 
		}while (chr != Terminator);
		
		
		
		//TODO:: Please write your application code 

		      SETBIT(PORTA,BIT(0))	//Sets PORTB6 as high i.e. turn on led

		      WaitMs(20);			//delay for 200ms(0.2s)

		      CLEARBIT(PORTA,BIT(0))	//Clears PORTB6(PB6 pin goes low) i.e turn off led

		      WaitMs(20);			//delay for 200ms(0.2s)
		
		
	 
		 
	  
	  
	  
	   

      while ((UCSRA & (1 << UDRE)) == 0) {}; // Do nothing until UDR is ready for more data to be written to it
      UDR = chr; // Echo back the received byte back to the computer
	  
	  while ((UCSRA & (1 << UDRE)) == 0) {}; // Do nothing until UDR is ready for more data to be written to it
      UDR = Terminator; // Echo back the received byte back to the computer
	   
	   
   }   
}



/* waits (pauses) for ms milliseconds (assumes clock at 16MHz) */

		      void WaitMs(unsigned int ms)

		      {

		      int i;

		    
 while (ms-- > 0)

		      {

		      /* 16380 (16k) clock cycles for 1ms; each time through loop

		      is 5 cycles (for loop control) */

		      for (i = 0; i < 1000; ++i)

		      {

		      } 

  

		      }



			  } 